        package com.gisdo.opengis.Controller;

        import org.springframework.web.bind.annotation.*;

        import java.util.*;
        import java.util.stream.Collectors;
        @CrossOrigin
        @RestController
        @RequestMapping("/filters")
        public class FiltersController {
            // 模拟数据库中的用户数据
            private final List<User> USERS = Arrays.asList(
                    new User("Alice", "Active", 25),
                    new User("Bob", "Inactive", 30),
                    new User("Catherine", "Pending", 35),
                    new User("David", "Active", 40),
                    new User("Eva", "Inactive", 45)
            );
            // 获取表格数据的接口
            @GetMapping("/data")
            public List<User> getTableData() {
                return USERS;
            }

            // 获取过滤条件的接口
            @GetMapping("/filters")
            public List<Object> getFilters(@RequestParam("colName") String colName) {
                System.err.println(colName);
                // 生成每个字段的唯一值列表
                return switch (colName) {
                    case "status" -> USERS.stream().map(User::getStatus).collect(Collectors.toList());
                    case "age" -> List.of(1,2,3,4,5,5,6,7,87,8,9,9);
                    default -> List.of();
                };
            }
            @GetMapping("/head")
            public List<HashMap<String,String>> getHead(){
                List<HashMap<String, String>> columns = new ArrayList<>();
                // 列“name”的配置
                HashMap<String, String> nameColumn = new HashMap<>();
                nameColumn.put("prop", "name");
                nameColumn.put("label", "Name");
                nameColumn.put("width", "180");
                nameColumn.put("filterable", "false");
                columns.add(nameColumn);
                // 列“status”的配置
                HashMap<String, String> statusColumn = new HashMap<>();
                statusColumn.put("prop", "status");
                statusColumn.put("label", "Status");
                statusColumn.put("width", "180");
                statusColumn.put("filterable", "true");
                columns.add(statusColumn);
                // 列“age”的配置
                HashMap<String, String> ageColumn = new HashMap<>();
                ageColumn.put("prop", "age");
                ageColumn.put("label", "Age");
                ageColumn.put("width", "120");
                ageColumn.put("filterable", "true");
                columns.add(ageColumn);

                return columns;
            }
        class User{
            private String name;
            private String status;
            private Integer age;

             User(String name, String status, Integer age) {
                this.name = name;
                this.status = status;
                this.age = age;
            }

            public String getName() { return name; }
            public void setName(String name) { this.name = name; }
            public String getStatus() { return status; }
            public void setStatus(String status) { this.status = status; }
            public Integer getAge() { return age; }
            public void setAge(Integer age) { this.age = age; }}
        }
