package com.gisdo.opengis.Controller;

import org.springframework.web.bind.annotation.*;
import com.gisdo.opengis.Utils.GdalUtils;
import com.gisdo.opengis.Model.GdalResult;

@CrossOrigin
@RestController
@RequestMapping("/shp")
public class ShpFeatureController {

    @GetMapping("/layercount")
    public GdalResult<Integer> GetLayerCount(@RequestParam String path) {
        System.out.println("Layer count request for path: " + path);
        // 检查路径是否为空
        if (path == null || path.isEmpty()) {
            return new GdalResult<>("路径不能为空", -1);
        }
        return GdalUtils.GetLayerCount(path);
    }

    @GetMapping("/featurecount")
    public GdalResult<Long> GetFeatureCount(@RequestParam String path) {
        System.out.println("Feature count request for path: " + path);
        if (path == null || path.isEmpty()) {
            return new GdalResult<>("路径不能为空", -1L);
        }
        return GdalUtils.GetFeatureCount(path);
    }
}
