package com.gisdo.opengis.Controller;

import Enums.ResponseStatus;
import com.gisdo.opengis.Entity.SiderTree;
import com.gisdo.opengis.Model.ResponseModel;
import com.gisdo.opengis.Service.Impl.SiderTreeImpl;
import org.apache.ibatis.annotations.Delete;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/sidertree")
public class SiderTreeController {
    private final SiderTreeImpl _iSiderTree;
    public SiderTreeController(SiderTreeImpl iSiderTree) {
            _iSiderTree = iSiderTree;
    }
    @GetMapping("/getTreesList")
    public ResponseEntity<List<SiderTree>> getTreesList() {
        return ResponseEntity.ok(_iSiderTree.getSiderTree());
    }
    @PostMapping("/addRootNode")
    public ResponseEntity<ResponseModel<Boolean>> addRootNode(@RequestBody SiderTree siderTree) {
       try {
           _iSiderTree.addRootNode(siderTree);
           return  ResponseEntity.ok(new ResponseModel<>(ResponseStatus.OK,true));
       }catch (Exception e){
           return ResponseEntity.status(500).body(new ResponseModel<>(ResponseStatus.ERROR, false));
       }
    }
    @PostMapping("/addChildRoot")
    public ResponseEntity<ResponseModel<Boolean>> addChildRoot(@RequestBody SiderTree siderTree) {
        try {
            _iSiderTree.addChildNode(siderTree);
            return  ResponseEntity.ok(new ResponseModel<>(ResponseStatus.OK,true));
        }catch (Exception e){
            return ResponseEntity.status(500).body(new ResponseModel<>(ResponseStatus.ERROR, false));
        }
    }
    @DeleteMapping("/delNode")
    public ResponseEntity<ResponseModel<Boolean>> delNode(@RequestBody List<Integer> nodeIdList) {
        try {
            _iSiderTree.removeNode(nodeIdList);
            return  ResponseEntity.ok(new ResponseModel<>(ResponseStatus.OK,true));
        }catch (Exception e){
            return ResponseEntity.status(500).body(new ResponseModel<>(ResponseStatus.ERROR, false));
        }
    }
    @PostMapping("/updateNode")
    public ResponseEntity<ResponseModel<Boolean>> updateNode(@RequestBody SiderTree siderTree) {
        try {
            _iSiderTree.alterNode(siderTree);
            return  ResponseEntity.ok(new ResponseModel<>(ResponseStatus.OK,true));
        }
        catch (Exception e){
            System.err.println(e);
            return ResponseEntity.status(500).body(new ResponseModel<>(ResponseStatus.ERROR, false));
        }
    }
}
