package com.gisdo.opengis.Service.Impl;

import com.gisdo.opengis.Entity.SiderTree;
import com.gisdo.opengis.Mapper.SiderTreeMapper;
import com.gisdo.opengis.Service.ISiderTree;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class SiderTreeImpl implements ISiderTree {
    private SiderTreeMapper _siderTreeMapper;
    public  SiderTreeImpl(SiderTreeMapper siderTreeMapper) {
        _siderTreeMapper = siderTreeMapper;
    }
    @Override
    public List<SiderTree> getSiderTree() {
        return _siderTreeMapper.getSiderTree();
    }

    @Override
    public void addRootNode(SiderTree siderTree) {
            _siderTreeMapper.addRootNode(siderTree);
    }

    @Override
    public void addChildNode(SiderTree siderTree) {
            _siderTreeMapper.addChildNode(siderTree);
    }

    @Override
    public void removeNode(List<Integer> nodeIdList) {
        // 遍历要删除的节点 ID 列表
        for (var nodeId : nodeIdList) {
            // 获取当前节点的所有子节点
            var childrenNodes = _siderTreeMapper.getChildren(nodeId);
            // 创建一个列表来存储子节点的 ID
            List<Integer> childIds = new ArrayList<>();
            for (var childrenNode : childrenNodes) {
                // 将每个子节点的 ID 添加到列表中
                childIds.add(childrenNode.getId());
            }
            // 递归调用 removeNode 方法，传递子节点 ID 列表
            if (!childIds.isEmpty()) {
                removeNode(childIds);
            }
        }
        // 删除当前节点 ID 列表
        _siderTreeMapper.removeNode(nodeIdList);
    }

    @Override
    public List<SiderTree> getChildren(int parentId){
        return _siderTreeMapper.getChildren(parentId);
    }

    @Override
    public void alterNode(SiderTree siderTree) {
        _siderTreeMapper.alterNode(siderTree);
    }
}
